/******************************************************************************
 * $Id: include/debug.h, v0.01 17:19 27.11.2010 TiN Exp $
 *
 * Copyright (c) 2010, xDevs.com ARM Microcontroller Software Support
 *
 * Debug controls
 *
 * Project maintainers:
 *  o Tsemenko Ilya  (ilya@xdevs.com)
 *  o Alex Gurin     (warder@xdevs.com)
 */

#ifndef DEBUG_H
#define DEBUG_H 

#include <types.h>
#include <macros.h>

#ifdef DEVEL_MODE /* enable debugs */

extern void debug_init(void);

extern int write_debug(uint8_t level, const char *format, ...);

#define macro_write_debug(level, ...)                       \
do {                                                        \
    if (level > 0) {                                        \
        write_debug(level, __FILE__ ": " __VA_ARGS__);      \
    } else {                                                \
        write_debug(level, __VA_ARGS__);                    \
    }                                                       \
} while (0)

#else /* disable debugs */

#define macro_write_debug(level, ...)

#endif /* DEVEL_MODE */

#define debug0(...)    macro_write_debug(0, __VA_ARGS__)
#define debug1(...)    macro_write_debug(1, __VA_ARGS__)

#endif /* DEBUG_H */
